{Checker for PERECRES}
Var
  Points    : Array[1..1000,1..2] Of Integer;
  N,M,K     : Integer;
  A         : Array[1..100,1..100] Of Integer;
  L         : Array[1..100] Of Integer;
  B,E       : Integer;
  S,BestS   : Longint;
  F1,F2,F3  : Text;
  Dif       : Boolean;

Procedure Done(Dif: Boolean);
  Var
    F : Text;
  Begin
    Assign(F,'$RESULT$.TXT');
    If Dif Then
             Begin
               {$I-}
               Erase(F);
               {$I+}
               If IOResult<>0 Then;
             End
           Else
             Begin
               Rewrite(F);
               WriteLn(F,ParamStr(4));
               Close(F);
             End;
    Halt;
  End;

Procedure Init;
  Begin
    Assign(F1,ParamStr(1));
    {$I-}
    Reset(F1);
    {$I+}
    If IOResult<>0 Then Done(True);
    Assign(F2,ParamStr(2));
    Reset(F2);
    Assign(F3,ParamStr(3));
    {$I-}
    Reset(F3);
    {$I+}
    If IOResult<>0 Then Done(True);
  End;

Procedure InputData;
  Var
    I,J,P,T : Integer;
  Begin
    ReadLn(F1,N);
    ReadLn(F1,M);
    ReadLn(F1,K);
    For I:=1 To N Do
      ReadLn(F1,Points[I,1],Points[I,2]);

    For I:=1 To M Do
      Begin
        ReadLn(F1,J,P,T);
        A[J,P]:=T;
        A[P,J]:=T;
        Inc(L[J]);
        Inc(L[P]);
      End;
    ReadLn(F1,B,E);
    Close(F1);
    ReadLn(F2,BestS);
    Close(F2);
    ReadLn(F3,S);
    If S>BestS Then Done(True);
  End;

Function IsLeft(A,B,C: Integer): Boolean;
  Var
    Q: Longint;
  Begin
    IsLeft:= (A=C) Or (((Points[C,1]-Points[A,1])*(Points[B,2]-Points[A,2])-
              (Points[C,2]-Points[A,2])*(Points[B,1]-Points[A,1]))<0);
  End;

Procedure CheckData;
  Var
    Q,W,V : Integer;
  Begin
    V:=0;
    ReadLn(F3,Q);
    While Q<>E Do
      Begin
        ReadLn(F3,W);
        If A[Q,W]=0 Then 
          Begin
	    Close(F3);
            Done(True);
          End;
        S:=S-A[Q,W];
        If (V<>0) And IsLeft(V,Q,W) Then Dec(S,L[Q]*K);
        V:=Q;
        Q:=W;
      End;
    Close(F3);
    Dif:=S<>0;
  End;

Begin
  Init;
  InputData;
  CheckData;
  Done(Dif);
End.